function Double_versus_uint
%ErrorCheck Double versus uint8, uint16, uint32 and nearest neighbor
%clear all;
close all;
Ileft = double(imread('image_left1.jpg'));
load('StereoParameterNiDouble');
    IleftRectNiDouble = 255*ones(Hboth,Wleft);
    IleftRectNiDouble(ind_new_leftNi) = (a1_leftNi .* Ileft(ind_1_leftNi) + a2_leftNi .* Ileft(ind_2_leftNi) +...
         a3_leftNi .* Ileft(ind_3_leftNi) + a4_leftNi .* Ileft(ind_4_leftNi));
    IleftRectNiDouble=uint8(IleftRectNiDouble); 
%8 bit bilinear a-parameters
    %Perform operations in 16 bit space
    load('StereoParameterNiUint8');
    Ileft16=uint16(Ileft);
    temp=uint16(2^7);
    a1_leftNi=uint16(a1_leftNi);
    a2_leftNi=uint16(a2_leftNi);
    a3_leftNi=uint16(a3_leftNi);
    a4_leftNi=uint16(a4_leftNi);
    IleftRectNiUint8 = 255*ones(Hboth,Wleft,'uint16');
    IleftRectNiUint8(ind_new_leftNi) = uint8((a1_leftNi .* Ileft16(ind_1_leftNi) + a2_leftNi .* Ileft16(ind_2_leftNi) +...
             a3_leftNi .* Ileft16(ind_3_leftNi) + a4_leftNi .* Ileft16(ind_4_leftNi))/temp);
     IleftRectNiUint8=uint8(IleftRectNiUint8);%previous uint8 did not change number format
               
%16 bit bilinear a-parameters
    %Perform operations in 32 bit space
    load('StereoParameterNiUint16');
    Ileft32=uint32(Ileft);
    temp=uint32(2^15);
    a1_leftNi=uint32(a1_leftNi);
    a2_leftNi=uint32(a2_leftNi);
    a3_leftNi=uint32(a3_leftNi);
    a4_leftNi=uint32(a4_leftNi);
    IleftRectNiUint16 = 255*ones(Hboth,Wleft,'uint32');
    IleftRectNiUint16(ind_new_leftNi) = uint8((a1_leftNi .* Ileft32(ind_1_leftNi) + a2_leftNi .* Ileft32(ind_2_leftNi) +...
         a3_leftNi .* Ileft32(ind_3_leftNi) + a4_leftNi .* Ileft32(ind_4_leftNi))/temp);
     IleftRectNiUint16=uint8(IleftRectNiUint16);
       
%32 bit bilinear a-parameters
    %Perform operations in 64 bit space  
    load('StereoParameterNiUint32');
    Ileft64=uint64(Ileft);
    temp=uint64(2^31);
    a1_leftNi=uint64(a1_leftNi);
    a2_leftNi=uint64(a2_leftNi);
    a3_leftNi=uint64(a3_leftNi);
    a4_leftNi=uint64(a4_leftNi);
        IleftRectNiUint32 = 255*ones(Hboth,Wleft,'uint64');
        IleftRectNiUint32(ind_new_leftNi) = uint8((a1_leftNi .* Ileft64(ind_1_leftNi) + a2_leftNi .* Ileft64(ind_2_leftNi) +...
             a3_leftNi .* Ileft64(ind_3_leftNi) + a4_leftNi .* Ileft64(ind_4_leftNi))/temp);
 
%Nearest neighbor
    %Since a is either 1 or 0 the number space has no influence  
    load('StereoParameterNiNNeighbor');
    Ileft64=uint64(Ileft);
    
    a1_leftNi=uint64(a1_leftNi);
    a2_leftNi=uint64(a2_leftNi);
    a3_leftNi=uint64(a3_leftNi);
    a4_leftNi=uint64(a4_leftNi);
        IleftRectNiNNeihgbor = 255*ones(Hboth,Wleft,'uint64');
        IleftRectNiNNeihgbor(ind_new_leftNi) = uint8((a1_leftNi .* Ileft64(ind_1_leftNi) + a2_leftNi .* Ileft64(ind_2_leftNi) +...
             a3_leftNi .* Ileft64(ind_3_leftNi) + a4_leftNi .* Ileft64(ind_4_leftNi)));         
%Perform statistics  
     Idiff8=double(IleftRectNiDouble)-double(IleftRectNiUint8);%calculate in double since negative values are expected 
     Idiff16=double(IleftRectNiDouble)-double(IleftRectNiUint16);
     Idiff32=double(IleftRectNiDouble)-double(IleftRectNiUint32); 
     IdiffNNeihgbor=double(IleftRectNiDouble)-double(IleftRectNiNNeihgbor);
     counts=zeros(256,4);
     counts(:,1) = imhist(uint8(Idiff8+128));%add 128 because imhist handles only positive values
     counts(:,2) = imhist(uint8(Idiff16+128));
     counts(:,3) = imhist(uint8(Idiff32+128));
     counts(:,4)=imhist(uint8(IdiffNNeihgbor+128));
%      counts=zeros(7,4);
%      counts(:,1)=counts8(126:132);
%      counts(:,2)=counts16(126:132);
%      counts(:,3)=counts32(126:132);
%      counts(:,4)=countsNNeihgbor(126:132);
     pixelCountTotal=double(Hboth*Wleft);
%Diplay results
    figure('NumberTitle','off','Name','statistics left image'); 
    set(gcf, 'Position', get(0,'Screensize')); % Maximize figure. 
   %uint8
    subplot(2,4,1)
    imshow(uint8(Idiff8*128+128));
    title(sprintf('Difference imageDouble-imageUint8 \nwhite: pixel value too small\n black: pixel value too big'));
    subplot(2,4,5)
    bar(-3:3,counts(126:132,1),'b');
    axis([-3 3 0 pixelCountTotal*1.1]);
    [str1,str2]=makeStrings(1,counts,pixelCountTotal);
    title(sprintf(['Difference count for uint8\n'  str1 '\n' str2]));

   %uint16
    subplot(2,4,2)
    imshow(uint8(Idiff16*128+128));
    title(sprintf('Difference imageDouble-imageUint16 \nwhite: pixel value too small\n black: pixel value too big'));
    subplot(2,4,6)
    hdl=bar(-3:3,counts(126:132,2),'b');
    axis([-3 3 0 pixelCountTotal*1.1]);
    [str1,str2]=makeStrings(2,counts,pixelCountTotal);
    title(sprintf(['Difference count for uint16\n'  str1 '\n' str2]));

   %uint32    
    subplot(2,4,3)
    imshow(uint8(Idiff32*128+128));
    title(sprintf('Difference imageDouble-imageUint32 \nwhite: pixel value too small\n black: pixel value too big'));
    subplot(2,4,7)
    hdl=bar(-3:3,counts(126:132,3),'b');
    axis([-3 3 0 pixelCountTotal*1.1]);
    [str1,str2]=makeStrings(3,counts,pixelCountTotal);
    title(sprintf(['Difference count for uint32\n'  str1 '\n' str2]));
 
   %NNeihgbor   
    subplot(2,4,4)
    imshow(uint8(IdiffNNeihgbor*128+128));
    title(sprintf('Difference imageDouble-imageNNeihgbor \nwhite: pixel value too small\n black: pixel value too big'));
    subplot(2,4,8)
    hdl=bar(-5:5,counts(124:134,4),'b');
    axis([-5 5 0 pixelCountTotal*1.1]);
    [str1,str2]=makeStrings(4,counts,pixelCountTotal);
    title(sprintf(['Difference count for NNeihgbor\n'  str1 '\n'      str2]));
   
%%Right image =============================================
Iright = double(imread('image_right1.jpg'));
    load('StereoParameterNiDouble');
    IrightRectNiDouble = 255*ones(Hboth,Wright);
    IrightRectNiDouble(ind_new_rightNi) = (a1_rightNi .* Iright(ind_1_rightNi) + a2_rightNi .* Iright(ind_2_rightNi) +...
         a3_rightNi .* Iright(ind_3_rightNi) + a4_rightNi .* Iright(ind_4_rightNi));
    IrightRectNiDouble=uint8(IrightRectNiDouble); 
%8 bit bilinear a-parameters
    %Perform operations in 16 bit space
    load('StereoParameterNiUint8');
    Iright16=uint16(Iright);
    temp=uint16(2^7);
    a1_rightNi=uint16(a1_rightNi);
    a2_rightNi=uint16(a2_rightNi);
    a3_rightNi=uint16(a3_rightNi);
    a4_rightNi=uint16(a4_rightNi);
    IrightRectNiUint8 = 255*ones(Hboth,Wright,'uint16');
    IrightRectNiUint8(ind_new_rightNi) = uint8((a1_rightNi .* Iright16(ind_1_rightNi) + a2_rightNi .* Iright16(ind_2_rightNi) +...
             a3_rightNi .* Iright16(ind_3_rightNi) + a4_rightNi .* Iright16(ind_4_rightNi))/temp);
     IrightRectNiUint8=uint8(IrightRectNiUint8);%previous uint8 did not change number format
               
%16 bit bilinear a-parameters
    %Perform operations in 32 bit space
    load('StereoParameterNiUint16');
    Iright32=uint32(Iright);
    temp=uint32(2^15);
    a1_rightNi=uint32(a1_rightNi);
    a2_rightNi=uint32(a2_rightNi);
    a3_rightNi=uint32(a3_rightNi);
    a4_rightNi=uint32(a4_rightNi);
    IrightRectNiUint16 = 255*ones(Hboth,Wright,'uint32');
    IrightRectNiUint16(ind_new_rightNi) = uint8((a1_rightNi .* Iright32(ind_1_rightNi) + a2_rightNi .* Iright32(ind_2_rightNi) +...
         a3_rightNi .* Iright32(ind_3_rightNi) + a4_rightNi .* Iright32(ind_4_rightNi))/temp);
     IrightRectNiUint16=uint8(IrightRectNiUint16);
       
%32 bit bilinear a-parameters
    %Perform operations in 64 bit space  
    load('StereoParameterNiUint32');
    Iright64=uint64(Iright);
    temp=uint64(2^31);
    a1_rightNi=uint64(a1_rightNi);
    a2_rightNi=uint64(a2_rightNi);
    a3_rightNi=uint64(a3_rightNi);
    a4_rightNi=uint64(a4_rightNi);
        IrightRectNiUint32 = 255*ones(Hboth,Wright,'uint64');
        IrightRectNiUint32(ind_new_rightNi) = uint8((a1_rightNi .* Iright64(ind_1_rightNi) + a2_rightNi .* Iright64(ind_2_rightNi) +...
             a3_rightNi .* Iright64(ind_3_rightNi) + a4_rightNi .* Iright64(ind_4_rightNi))/temp);
 
%Nearest neighbor
    %Since a is either 1 or 0 the number space has no influence  
    load('StereoParameterNiNNeighbor');
    Iright64=uint64(Iright);
    
    a1_rightNi=uint64(a1_rightNi);
    a2_rightNi=uint64(a2_rightNi);
    a3_rightNi=uint64(a3_rightNi);
    a4_rightNi=uint64(a4_rightNi);
        IrightRectNiNNeihgbor = 255*ones(Hboth,Wright,'uint64');
        IrightRectNiNNeihgbor(ind_new_rightNi) = uint8((a1_rightNi .* Iright64(ind_1_rightNi) + a2_rightNi .* Iright64(ind_2_rightNi) +...
             a3_rightNi .* Iright64(ind_3_rightNi) + a4_rightNi .* Iright64(ind_4_rightNi)));         
%Perform statistics  
     Idiff8=double(IrightRectNiDouble)-double(IrightRectNiUint8);%calculate in double since negative values are expected 
     Idiff16=double(IrightRectNiDouble)-double(IrightRectNiUint16);
     Idiff32=double(IrightRectNiDouble)-double(IrightRectNiUint32); 
     IdiffNNeihgbor=double(IrightRectNiDouble)-double(IrightRectNiNNeihgbor);
     counts=zeros(256,4);
     counts(:,1) = imhist(uint8(Idiff8+128));%add 128 because imhist handles only positive values
     counts(:,2) = imhist(uint8(Idiff16+128));
     counts(:,3) = imhist(uint8(Idiff32+128));
     counts(:,4)=imhist(uint8(IdiffNNeihgbor+128));
%      counts=zeros(7,4);
%      counts(:,1)=counts8(126:132);
%      counts(:,2)=counts16(126:132);
%      counts(:,3)=counts32(126:132);
%      counts(:,4)=countsNNeihgbor(126:132);
     pixelCountTotal=double(Hboth*Wright);
%Diplay results
    figure('NumberTitle','off','Name','statistics right image'); 
    set(gcf, 'Position', get(0,'Screensize')); % Maximize figure. 
   %uint8
    subplot(2,4,1)
    imshow(uint8(Idiff8*128+128));
    title(sprintf('Difference imageDouble-imageUint8 \nwhite: pixel value too small\n black: pixel value too big'));
    subplot(2,4,5)
    bar(-3:3,counts(126:132,1),'b');
    axis([-3 3 0 pixelCountTotal*1.1]);
    [str1,str2]=makeStrings(1,counts,pixelCountTotal);
    title(sprintf(['Difference count for uint8\n'  str1 '\n' str2]));

   %uint16
    subplot(2,4,2)
    imshow(uint8(Idiff16*128+128));
    title(sprintf('Difference imageDouble-imageUint16 \nwhite: pixel value too small\n black: pixel value too big'));
    subplot(2,4,6)
    hdl=bar(-3:3,counts(126:132,2),'b');
    axis([-3 3 0 pixelCountTotal*1.1]);
    [str1,str2]=makeStrings(2,counts,pixelCountTotal);
    title(sprintf(['Difference count for uint16\n'  str1 '\n' str2]));

   %uint32    
    subplot(2,4,3)
    imshow(uint8(Idiff32*128+128));
    title(sprintf('Difference imageDouble-imageUint32 \nwhite: pixel value too small\n black: pixel value too big'));
    subplot(2,4,7)
    hdl=bar(-3:3,counts(126:132,3),'b');
    axis([-3 3 0 pixelCountTotal*1.1]);
    [str1,str2]=makeStrings(3,counts,pixelCountTotal);
    title(sprintf(['Difference count for uint32\n'  str1 '\n' str2]));
 
   %NNeihgbor   
    subplot(2,4,4)
    imshow(uint8(IdiffNNeihgbor*128+128));
    title(sprintf('Difference imageDouble-imageNNeihgbor \nwhite: pixel value too small\n black: pixel value too big'));
    subplot(2,4,8)
    hdl=bar(-5:5,counts(124:134,4),'b');
    axis([-5 5 0 pixelCountTotal*1.1]);
    [str1,str2]=makeStrings(4,counts,pixelCountTotal);
    title(sprintf(['Difference count for NNeihgbor\n'  str1 '\n'      str2]));
   
end%end function

function [str1,str2]=makeStrings(col,counts,pixelCountTotal)
    sum1=sum(counts(1:128,col));
    if sum1==0
        str1='no pixel value is too large';
    elseif sum1==counts(128,col)
        str1=strcat(num2str(sum1), ' (', num2str(sum1*100/pixelCountTotal,2),'%%)', ' pixel values are by one too large' ); 
    else
        str1=strcat(num2str(sum1), ' (', num2str(sum1*100/pixelCountTotal,2),'%%)', ' pixel values are too large' ); 
    end
    sum1=sum(counts(130:256,col));
    if sum1==0
        str2='  no pixel value is too small\n';    
    elseif sum1==counts(130,col)
        str2=strcat(num2str(sum1), ' (', num2str(sum1*100/pixelCountTotal,2),'%%)', ' pixel values are by one too small','\n' ); 

    else
        str2=strcat(num2str(sum1), ' (', num2str(sum1*100/pixelCountTotal,2),'%%)', ' pixel values are too small','\n' ); 
    end
    for k = -2:2
         if counts(k+129,col)>0
            text(k,counts(k+129,col)+0.4,num2str(counts(k+129,col)) ,'HorizontalAlignment','center','VerticalAlignment','bottom');
         end
     end
end